<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Repository;

use Dedi\SyliusCustomerPricingPlugin\Entity\Customer\OrganizationInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ChannelInterface;
use Sylius\Component\Core\Model\CustomerInterface;
use Sylius\Component\Core\Model\ProductVariantInterface;
use Sylius\Component\Customer\Model\CustomerGroupInterface;
use Sylius\Component\Resource\Repository\RepositoryInterface;

interface ChannelPricingRepositoryInterface extends RepositoryInterface
{
    public function findAllForProductVariantByType(ProductVariantInterface $productVariant, string $type): Collection;

    public function findAllDefaultsForProductVariant(ProductVariantInterface $productVariant): Collection;

    public function findAllDefaultsForProductVariantAndChannel(string $channelCode, ProductVariantInterface $productVariant): array;

    public function findAllForCustomerForProductVariant(ProductVariantInterface $productVariant, CustomerInterface $customer): Collection;

    public function findAllForCustomerForProductVariantAndChannel(string $channelCode, ProductVariantInterface $productVariant, CustomerInterface $customer): array;

    public function findAllForOrganizationForProductVariant(ProductVariantInterface $productVariant, OrganizationInterface $organization): Collection;

    public function findAllForOrganizationForProductVariantAndChannel(string $channelCode, ProductVariantInterface $productVariant, OrganizationInterface $organization): array;

    public function findAllForCustomerGroupForProductVariant(ProductVariantInterface $productVariant, CustomerGroupInterface $customerGroup): Collection;

    public function findAllForCustomerGroupForProductVariantAndChannel(string $channelCode, ProductVariantInterface $productVariant, CustomerGroupInterface $customerGroup): array;
}
