<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusCustomerPricingPlugin\Application\src\Entity;

use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\Organization\OrganizationChannelPricingInterface;
use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\Organization\OrganizationChannelPricingTrait;
use Dedi\SyliusCustomerPricingPlugin\Entity\Customer\OrganizationInterface;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 *
 * @ORM\Table(name="dedi_customer_pricing_organization_channel_pricing")
 */
class OrganizationChannelPricing extends ChannelPricing implements OrganizationChannelPricingInterface
{
    /**
     * @ORM\ManyToOne(targetEntity="Dedi\SyliusCustomerPricingPlugin\Entity\Customer\OrganizationInterface")
     * @ORM\JoinColumn(name="organization_id", referencedColumnName="id", nullable=false, onDelete="CASCADE")
     */

    protected ?OrganizationInterface $organization = null;

    use OrganizationChannelPricingTrait;
}
